<?php
/*
 File Manager (fileman)
 (c)2004, C97.net

 Params:
 - $cur_dir = directory to display, relative to fileman.php OR caller script's.
 - $script = script filename (usually fileman.php)
 - $fileman_cmd = empty/browse => browse a dir
 del => delete a file *
 ren => rename a file *
 *) need more param: $fileman_fn = full name & dir of processed file
 - $default_tool = additional tools, script name, e.g process.php. the script must accept $filename
*/

require './../includes/admin_init.php';
admin_check ('sa');

// demo mode?
if ($config['demo_mode']) admin_die ('demo_mode');

// set vars
$cur_dir = get_param ('cur_dir');
$fileman_cmd = get_param ('fileman_cmd', 'browse');
$fileman_fn = get_param ('fileman_fn');
$new_filename = get_param ('new_filename');
$redir = get_param ('redir');
$default_tool = get_param ('default_tool');

// catch post param (this is actually BAD approach!)
$cur_dir = post_param ('post_dir', $cur_dir);
$fileman_cmd = post_param ('fileman_cmd', $fileman_cmd);
$redir = post_param ('redir', $redir);
$default_tool = post_param ('default_tool', $default_tool);

// init
$abs_path = realpath ($cur_dir);
$del_link = "<img src=\"../".$config['skin']."/images/del.gif\" border=\"0\" title=\"delete\">";
$ren_link = "<img src=\"../".$config['skin']."/images/ren.gif\" border=\"0\" title=\"rename\">";

if (empty ($cur_dir)) $cur_dir = './';
// if (strlen ($abs_path) < strlen ($config['abs_path'])) admin_die ('not_allowed');

// load tpl
$tpl = load_tpl ($config['skin']."/admin/fileman.tpl"); // <-- modify if necess.
$txt['block_fileman_item'] = '';
$dir_array = array(); $file_array = array(); $ttl_size = 0; $f = 0; $d = 0;

switch ($fileman_cmd)
{
	case 'do_upload':
	 $tmp = $_FILES['upload']['tmp_name'];
	 $fn = $_FILES['upload']['name'];
	 $cur_dir = $_POST['cur_dir'];
	 if (!move_uploaded_file ($tmp, $cur_dir.$fn)) hacker_die ();
	 header ("Location: $_POST[redir]");
	 die;
	break;


	case 'do_ren':
	 rename ($cur_dir.$fileman_fn, $cur_dir.$new_filename);
	 header ("Location: $redir");
	 die;
	break;


	case 'do_del':
	 unlink ($cur_dir.$fileman_fn);
	 header ("Location: $redir");
	 die;
	break;


	case 'del':
	 $txt['redir'] = $_SERVER['HTTP_REFERER'];
	 $txt['cur_dir'] = $cur_dir;
	 $txt['dirname'] = realpath ($cur_dir);
	 $txt['fileman_fn'] = $fileman_fn;
	 $txt['main_body'] = quick_tpl ($tpl, $txt);
	break;


	case 'ren':
	 $txt['redir'] = $_SERVER['HTTP_REFERER'];
	 $txt['cur_dir'] = $cur_dir;
	 $txt['dirname'] = realpath ($cur_dir);
	 $txt['fileman_fn'] = $fileman_fn;
	 $txt['main_body'] = quick_tpl ($tpl, $txt);
	break;


	case 'browse':
	 // start retreiving files
	 $handle = @opendir($cur_dir);
	 if (!$handle) admin_die ('not_allowed');
	 while (false !== ($file = readdir($handle)))
	 {
		$fn = $cur_dir.$file;
		$s = stat ($fn);
		$f_size = number_format ($s['size']);
		$f_mtime = date ("m-d-Y g:i a", $s['mtime']);

		// put dir to dir_array and file to file_array, useful when sorting (dir first, next file)
		// may be we can use additional colum (dir) and merge these arrays into one array
		if (is_dir ($fn))
		{
			$d++;
			$cd = $cur_dir.$file;
			$dir_array[$d]['key'] = strtolower ($file); // <- trick for SORTING
			$dir_array[$d]['name'] = "<B><a href=\"fileman.php?default_tool=$default_tool&cur_dir=$cd/\">$file/</a></B>";
			$dir_array[$d]['size'] = '';
			$dir_array[$d]['mtime'] = $f_mtime;
			$dir_array[$d]['tools'] = '';
			if ($file == '.') $d--;
		}
		else
		{
			$f++;
			$ttl_size = $ttl_size + $s['size'];
			$file_array[$f]['key'] = strtolower ($file);
			$file_array[$f]['name'] = $file;
			$file_array[$f]['size'] = $f_size;
			$file_array[$f]['mtime'] = $f_mtime;
			$file_array[$f]['tools'] = "<a href=\"fileman.php?fileman_cmd=del&cur_dir=$cur_dir&fileman_fn=$file\">$del_link</a> "
			                          ."<a href=\"fileman.php?fileman_cmd=ren&cur_dir=$cur_dir&fileman_fn=$file\">$ren_link</a> ";
			if ($default_tool) $file_array[$f]['name'] = "<a href=\"$default_tool?filename=$cur_dir$file\">$file</a>";
		}
	 }

	 closedir($handle);

	 // sort & merge
	 asort ($dir_array);
	 asort ($file_array);
	 $dsp = array_merge ($dir_array, $file_array);

	 // output
	 while (list ($key, $val) = each ($dsp)) $txt['block_fileman_item'] .= quick_tpl ($tpl_block['fileman_item'], $dsp[$key]);
	 $txt['redir'] = "fileman.php?cur_dir=$cur_dir";
	 $txt['cur_dir'] = $cur_dir;
	 $txt['ttl_size'] = number_format($ttl_size);
	 $txt['num_files'] = number_format(count ($file_array));
	 $txt['num_dirs'] = number_format(count ($dir_array));
	 $txt['abs_path'] = $abs_path;
	 $txt['main_body'] = quick_tpl ($tpl, $txt);
	break;
}

echo quick_tpl (load_tpl ($config['skin']."/admin/outline.tpl"), $txt);
?>