<?php
// splitSqlFile => taken from phpMyAdmin (c)phpMyAdmin.net
function splitSqlFile(&$ret, $sql, $release = '32270')
{
        $sql          = trim($sql);
        $sql_len      = strlen($sql);
        $char         = '';
        $string_start = '';
        $in_string    = FALSE;
        $time0        = time();

        for ($i = 0; $i < $sql_len; ++$i) {
            $char = $sql[$i];

            // We are in a string, check for not escaped end of strings except for
            // backquotes that can't be escaped
            if ($in_string) {
                for (;;) {
                    $i         = strpos($sql, $string_start, $i);
                    // No end of string found -> add the current substring to the
                    // returned array
                    if (!$i) {
                        $ret[] = $sql;
                        return TRUE;
                    }
                    // Backquotes or no backslashes before quotes: it's indeed the
                    // end of the string -> exit the loop
                    else if ($string_start == '`' || $sql[$i-1] != '\\') {
                        $string_start      = '';
                        $in_string         = FALSE;
                        break;
                    }
                    // one or more Backslashes before the presumed end of string...
                    else {
                        // ... first checks for escaped backslashes
                        $j                     = 2;
                        $escaped_backslash     = FALSE;
                        while ($i-$j > 0 && $sql[$i-$j] == '\\') {
                            $escaped_backslash = !$escaped_backslash;
                            $j++;
                        }
                        // ... if escaped backslashes: it's really the end of the
                        // string -> exit the loop
                        if ($escaped_backslash) {
                            $string_start  = '';
                            $in_string     = FALSE;
                            break;
                        }
                        // ... else loop
                        else {
                            $i++;
                        }
                    } // end if...elseif...else
                } // end for
            } // end if (in string)

            // We are not in a string, first check for delimiter...
            else if ($char == ';') {
                // if delimiter found, add the parsed part to the returned array
                $ret[]      = substr($sql, 0, $i);
                $sql        = ltrim(substr($sql, min($i + 1, $sql_len)));
                $sql_len    = strlen($sql);
                if ($sql_len) {
                    $i      = -1;
                } else {
                    // The submited statement(s) end(s) here
                    return TRUE;
                }
            } // end else if (is delimiter)

            // ... then check for start of a string,...
            else if (($char == '"') || ($char == '\'') || ($char == '`')) {
                $in_string    = TRUE;
                $string_start = $char;
            } // end else if (is start of string)

            // ... for start of a comment (and remove this comment if found)...
            else if ($char == '#'
                     || ($char == ' ' && $i > 1 && $sql[$i-2] . $sql[$i-1] == '--')) {
                // starting position of the comment depends on the comment type
                $start_of_comment = (($sql[$i] == '#') ? $i : $i-2);
                // if no "\n" exits in the remaining string, checks for "\r"
                // (Mac eol style)
                $end_of_comment   = (strpos(' ' . $sql, "\012", $i+2))
                                  ? strpos(' ' . $sql, "\012", $i+2)
                                  : strpos(' ' . $sql, "\015", $i+2);
                if (!$end_of_comment) {
                    // no eol found after '#', add the parsed part to the returned
                    // array if required and exit
                    if ($start_of_comment > 0) {
                        $ret[]    = trim(substr($sql, 0, $start_of_comment));
                    }
                    return TRUE;
                } else {
                    $sql          = substr($sql, 0, $start_of_comment)
                                  . ltrim(substr($sql, $end_of_comment));
                    $sql_len      = strlen($sql);
                    $i--;
                } // end if...else
            } // end else if (is comment)

            // ... and finally disactivate the "/*!...*/" syntax if MySQL < 3.22.07
            else if ($release < 32270
                     && ($char == '!' && $i > 1  && $sql[$i-2] . $sql[$i-1] == '/*')) {
                $sql[$i] = ' ';
            } // end else if

            // loic1: send a fake header each 30 sec. to bypass browser timeout
            $time1     = time();
            if ($time1 >= $time0 + 30) {
                $time0 = $time1;
                header('X-pmaPing: Pong');
            } // end if
        } // end for

        // add any rest to the returned array
        if (!empty($sql) && ereg('[^[:space:]]+', $sql)) {
            $ret[] = $sql;
        }

        return TRUE;

} // end of the 'splitSqlFile()' function


$err = '';
$cmd = $_POST['cmd'];
$today = date ('Y-m-d');
if (empty($_POST['db_hostname'])) $err .= '<li>Database server hostname is empty!</li>';
if (empty($_POST['db_name'])) $err .= '<li>Database name is empty!</li>';
if (empty($_POST['db_username'])) $err .= '<li>Database username is empty!</li>';
if (empty($_POST['db_passwd'])) $err .= '<li>Database password is empty!</li>';
if (empty($_POST['admin_email'])) $err .= '<li>Administrator email is empty!</li>';
if (empty($_POST['admin_username'])) $err .= '<li>Administrator username is empty!</li>';
if (empty($_POST['admin_passwd'])) $err .= '<li>Administrator password is empty!</li>';
if (empty($_POST['admin_passwd_confirm'])) $err .= '<li>Administrator password (confirm) is empty!</li>';
if ($_POST['admin_passwd'] != $_POST['admin_passwd_confirm']) $err .= '<li>Administrator password doesn\'t match!</li>';

// if no form error, continue to db connection
if (empty($err))
   { if (!$dbh=@mysql_pconnect ($_POST['db_hostname'], $_POST['db_username'], $_POST['db_passwd']))
         $err .= '<li>Can not connect to database. Check db configuration & password!</li>'; }

// connect to db
if (empty($err))
   { if (!$dbh=@mysql_select_db($_POST['db_name'], $dbh))
         $err .= '<li>Can not connect to database. Check db configuration & password!</li>'; }

// read old config for upgrade
if (empty($err) && $cmd=='upgrade')
   { $res = mysql_query ("SELECT * FROM m_config");
     while ($row = mysql_fetch_array ($res)) $old_config[$row['config_id']] = $row['config_value']; }

// if no db error, create DB
if (empty($err))
   { $sql = '';
     if ($cmd == 'new')
        $fn = 'install.sql';
     else
        $fn = 'upgrade.sql';

     $cmd_sql = array ();
     $zp = gzopen($fn, "r");
     while ($j = gzgets ($zp, 4096)) $sql .= $j;
     gzclose ($zp);
     splitSqlFile ($cmd_sql, $sql);
     while (list ($key, $val) = each ($cmd_sql)) mysql_query ($val); }

// if no db[2] error, update configuration
if (empty($err))
   { mysql_query ("UPDATE m_config SET config_value='".date('Y-m-d')."' WHERE config_id='site_start'");
     mysql_query ("UPDATE m_config SET config_value='$_POST[abs_url]' WHERE config_id='site_url'");
     mysql_query ("UPDATE m_config SET config_value='$_POST[abs_path]' WHERE config_id='abs_path'");
     mysql_query ("UPDATE m_config SET config_value='$_POST[gd_ver]' WHERE config_id='gd_library'");
     mysql_query ("INSERT INTO m_user
                   VALUES ('$_POST[admin_username]', '$_POST[admin_passwd]', '$_POST[admin_email]',
                   'sa', 'site administrator', '".date('Y-m-d')."')"); }

// install sample data?
if (empty($err) && !empty($_POST['sample_data']))
   { $sql = ''; $cmd_sql = array ();
     $zp = gzopen('demo.sql', "r");
     while ($j = gzgets ($zp, 4096)) $sql .= $j;
     gzclose ($zp);

     splitSqlFile ($cmd_sql, $sql);
     while (list ($key, $val) = each ($cmd_sql)) mysql_query ($val); }

// ... and create db_config.php
if (empty($err))
   { $tpl = '';
     $fp = fopen('db_config.tpl','r');
     while(!feof($fp)) $tpl .= @fgets($fp,4096);
     $tpl = preg_replace ("/{\\$([a-zA-Z0-9\-_]+)}/e", "\$_POST['\\1']", $tpl);
     fclose ($fp);

     $fp = @fopen ('../includes/db_config.php', 'w-');
     @fwrite ($fp, $tpl);
     @fclose ($fp);

     if (!file_exists ('../includes/db_config.php')) $err_cfg = 1; else $err_cfg = 0; }

// ..., finally, log this user as admin
$admin_passwd = md5 ($_POST['admin_passwd']);
setcookie ("m_username", $_POST['admin_username'], time()+31536000, "/");
setcookie ("m_passwd", $admin_passwd, time()+31536000, "/");


// create output
if (!empty($err))
    $msg = '<font color="#FF0000"><ul>'.$err.'</ul>Press &lt;back&gt; on your browser and correct it!</font>';
else
    $msg = '<p><B>SUCCESS!</B> mBlog has been installed on your server.</p>'
          .'<p>mBlog has also created a user & administrator under the name you filled earlier. Use that username & password to manage '
          .'your directory.<BR> If there is any problem, do not hestitate to contact us. Thank you for choosing mBlog!</p>'
          .'<p>Don\'t forget to remove <b>install/</b> directory before using mBlog.</p>'
          .'<p>Now would be a good time to manage your web. <a href="../admin/index.php">Click to continue to administration panel</a></p>';

if (!empty($err_cfg))
	$msg = '<p><B>FAILED!</B> mBlog has reached the final step succesfully, but can not write configuration '
	      .'file into <b>includes/db_config.php</b>. The good news is you can manually finish the final step by '
	      .'following the following instruction:'
	      .'<ol><li>Copy and paste the following text into a text editor.</li>'
	      .'<li>Save it as <b>db_config.php</b>.</li>'
	      .'<li>Upload the file using your FTP program onto your server in <b>includes</b> directory.</li>'
	      .'<li>And go to <a href="../admin/index.php">admin panel</a>.</ol>'
	      .'<p align="center"><textarea cols="80" rows="10">'.$tpl.'</textarea></p>';
?>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta name="GENERATOR" content="Microsoft FrontPage 5.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<title>mBlog: Installation</title>
<style>
<!--
body         { font-family: Arial,Verdana,Helvetica; font-size: 10pt }
td           { font-size: 10pt }
.section		 { color:#FFFFFF; font-weight:bold; text-align:center }
-->
</style>
</head>

<body>

    <table border="2" cellspacing="0" style="border-collapse: collapse" bordercolor="#3366CC" width="90%" align="center">
      <tr>
        <td width="100%">
        <table border="1" cellspacing="0" style="border-collapse: collapse" bordercolor="#FFFFFF" width="100%" bgcolor="#EBEBEB">
          <tr>
            <td width="100%" bgcolor="#3366CC">
            <p class="section">Installation Process</p>
            </td>
          </tr>
          <tr>
            <td width="100%"><?php echo $msg ?></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>

</body>
</html>