<?php
require "./includes/user_init.php";

// convert -_ into bullet
function bullet_msg ($msg)
{
	if (strpos ($msg, '-_'))
	{
		$msg = str_replace ('-_', "</li>\n<li>", $msg);
		$msg = substr ($msg, 0, -4);
		$msg = "<ul><li>$msg</ul>";
	}
	else
	{
		$msg = "<ul><li>$msg</li></ul>";
	}
	return $msg;
}


// convert -_ into comma
function comma_msg ($msg)
{
	if (strpos ($msg, '-_'))
	{
		$msg = str_replace ('-_', ',', $msg);
		$msg = substr ($msg, 0, -1);
	}
	return $msg;
}

$admin = get_param ('admin');
$url = get_param ('url');
$r = get_param ('r');

// if loop -> go to front page.
if ($r) redir ($config['site_url']);

if (empty ($url))
{
	if (empty ($_SERVER['HTTP_REFERER']))
	{
		if ($admin)
			$url = $config['site_url'].'/admin/summary.php';
		else
			$url = $config['site_url'].'/index.php';
	}
	else
		$url = $_SERVER['HTTP_REFERER'];
}


// add loop tag
if (strpos ($url, '?')) $repeat = '&amp;r=1'; else $repeat = '?r=1';
if (strpos ($url, '&amp;r=1') || strpos ($url, '?r=1')) $repeat = '';
if (is_numeric ($url))
	$txt['url'] = "<a href=\"JavaScript:history.go($url)\">Return</a>";
else
	$txt['url'] = "<a href=\"$url$repeat\">Return</a>";

$id = strtoupper (get_param ('id'));
$msg = stripslashes (get_param ('msg'));
if (empty ($id) && !empty ($msg)) $id = 'ECHO';

switch ($id)
{
	case 'NOT_YOUR':
	 $txt['title'] = 'It\'s not your blog!';
	 $txt['message'] = 'Only blog creator or site administrator can edit this blog.';
	break;

	case 'NO_UID':
	 $txt['title'] = 'Invalid User ID or a guest!';
	 $txt['message'] = '';
	break;

	case 'INVALID_VISUAL':
	 $txt['title'] = 'Visual Confirmation Failed!';
	 $txt['message'] = 'Please enter a correct visual confirmation code.';
	break;

	case 'NO_BLOG':
	 $txt['title'] = 'Where\'s the blog!?';
	 $txt['message'] = 'I can\'t find my blog!';
	break;

	case 'DEMO_MODE':
	 $txt['title'] = 'Demo Mode!';
	 $txt['message'] = 'Cart97 PRO is currently running at demo mode.<br />Changes not saved!';
	break;

	case 'TPL_ONLY':
	 $txt['title'] = 'Can Not Open File!';
	 $txt['message'] = 'You are about to open a not skin-file. Editor only works for skin files (*.tpl).';
	break;

	case 'PASSWD_CHANGED':
	 $txt['title'] = 'Password Changed!';
	 $txt['message'] = 'Your password has been changed. You need to re-login.';
	break;

	case 'MINIMUM_3':
	 $txt['title'] = 'Minimum Three Characters!';
	 $txt['message'] = 'Can not proceed search. Minimum 3 characters for search query required!';
	break;

	case 'SA_ONLY';
	 $txt['title'] = 'Site Administrator Only!';
	 $txt['message'] = 'This feature is for site admin only!';
	break;

	case 'TELL_ERROR':
	 $txt['title'] = 'Failed!';
	 $txt['message'] = 'You have not fill all necessary fields. Please retry.';
	break;

	case 'TELL_OK':
	 $txt['title'] = 'Success!';
	 $txt['message'] = 'Email has been sent to '.$msg.'. Thank you.';
	break;

	case 'COMMENT_ERR':
	 $txt['title'] = 'Comment Failed!';
	 $txt['message'] = 'You have not fill all necessary fields. Please retry.';
	break;

	case 'COMMENT_OK':
	 $txt['title'] = 'Review Success!';
	 $txt['message'] = 'Review has been received. Thank you.';
	break;

	case 'NOT_MEMBER':
	 $txt['title'] = 'Member Only!';
	 $txt['message'] = 'This page is for member only!';
	break;

	case 'USERNAME_NOT_FOUND':
	 $txt['title'] = 'Username Not Available!';
	 $txt['message'] = 'Username is not found or no longer available!';
	break;

	case 'ADMIN_CAN_NOT_UPLOAD':
	 $txt['title'] = 'Upload Failed!';
	 $txt['message'] = 'Can not upload file to server. Make sure <b>images/products</b> directory is writeable!';
	break;

	case 'ADMIN_ERROR':
	 $txt['title'] = 'FAILED!';
	 $txt['message'] = 'Last action failed! Please try again!';
	break;

	case 'ADMIN_OK':
	case 'SQL_OK':
	 $txt['title'] = 'SUCCESS!';
	 $txt['message'] = 'Last action has been done successfully!';
	break;

	case 'REGISTER_ERROR':
	 $txt['title'] = 'Register Error!';
	 $txt['message'] = 'Error in:'.bullet_msg ($msg);
	break;

	case 'UPDATE_ERROR':
	 $txt['title'] = 'Profile Error!';
	 $txt['message'] = 'Error in:'.bullet_msg ($msg);
	break;

	case 'LOST_ERROR':
	 $txt['title'] = 'Password Retrival Failed!';
	 $txt['message'] = 'Username/email not found.';
	break;

	case 'LOST_OK':
	 $txt['title'] = 'Password Retrival Success!';
	 $txt['message'] = 'An email about your username &amp; password has been sent. Check your inbox.';
	break;

	case 'BAD_LOGIN':
	 $txt['title'] = 'Can not Login!';
	 $txt['message'] = 'Wrong password or bad username.';
	break;

	case 'SQL_ERROR':
	 $txt['title'] = 'SQL Error!';
	 $txt['message'] = $msg;
	break;

	case 'MSG_ABOUT':
	 $txt['title'] = 'Copyright(c)2004-05, C97.net';
	 $txt['message'] = 'This has been a product of <a href="http://www.c97.net">C97dotnet</a>. Do NOT remove this copyright! '
	                  .'Removing this copyright information can result in copyright infrigment!';
	break;

	default:
	 $txt['title'] = 'Undefined Error!';
	 $txt['message'] = 'Error code: '.$id;
	 if ($msg) $txt['message'] .= '<BR>Additional Message: '.$msg;
	 $txt['url'] .= "<BR /><a href=\"mailto:\">Contact</a> administrator for more information";
	break;
}

if ($admin)
{
	$tpl_mode = 'admin';
	echo quick_tpl (load_tpl ($config['skin']."/msg.tpl"), $txt);
}
else
{
	$tpl_mode = 'user';
	$txt['main_body'] = quick_tpl (load_tpl ($config['skin']."/msg.tpl"), $txt);
	flush_tpl ();
}
?>